; INSTALL.ASM
; (c) 1989, 1990 Ashok P. Nadkarni
; Addition of /c,l,w,o,t & z options by David Abbott (dfa),  Nov-Dec, 1990.
; Improvements to locate_cmdedit by dfa,  Jan 1991.
; also /k option added May 1991 and /n added July 1991.
; /a and /y options added by dfa and wd,  and /x by wd June 1992.
; NODIRS added by Jason Hood (jmh), 9 March, 1997.
; Switcher and improvement to locate_cmdedit by jmh, 11 March, 1997.
; Moved config file code from cmdedit.asm, jmh, 13 March.
; Moved getargs from utl.asm, jmh, 15 March.
;
; This code is the installation code for CMDEDIT. This file must be
; linked last !

; These moved from cmdedit.asm by jmh
SIGNATURE2 equ <"PC Magazine">
SIGNATURE3 equ <"Ashok P. Nadkarni">
SIGNATURE4 equ <"Extensions by D. Abbott & W. Davison - v6">
SIGNATURE5 equ <"Further extended by Jason Hood - v1">

	INCLUDE common.inc
	INCLUDE ascii.inc
	INCLUDE dos.inc
	INCLUDE general.inc

	PUBLIC	install_begin
	PUBLIC	install
	PUBLIC	file_error
	PUBLIC	abort_install
IFNDEF NODIRS
	PUBLIC	dirstk_error
ENDIF
	PUBLIC	macrosize
	PUBLIC	symsize
	PUBLIC	dossize
IFNDEF NODIRS
	PUBLIC	dirsize
ENDIF
	PUBLIC	process_args
	PUBLIC	read_cmdfile

CSEG	SEGMENT	BYTE PUBLIC 'CODE'
	EXTRN	cmdlen:BYTE
	EXTRN	default_imode:BYTE
	EXTRN	auto_recall:BYTE
	EXTRN	pgm_name:BYTE
	EXTRN	silent:BYTE
	EXTRN	macro_ignore_char:BYTE
	EXTRN	mfilename:BYTE
	EXTRN	mfile_seen:BYTE
	EXTRN	mfile_handle:WORD
	EXTRN	linebuf:BYTE
	EXTRN	lastchar:WORD
	EXTRN	source:WORD
	EXTRN	cmdedit_cmd:PROC
	EXTRN	skip_whitespace:PROC
	EXTRN	isspace:PROC
	EXTRN	prev_isr1b:WORD
	EXTRN	prev_isr2f:WORD
	EXTRN	enable_dircmds:BYTE
	EXTRN	dos_version_major:BYTE
	EXTRN	dos_version_minor:BYTE
	EXTRN	old_int21vec:WORD
	EXTRN	cmdedit:PROC
	EXTRN	our_break_handler:PROC
	EXTRN	our_mpx_handler:PROC	;added by jmh
	EXTRN	init_over:PROC
	EXTRN	cmdedit_isr:PROC
	EXTRN	getkey_funcnum:BYTE
;dfa added the following
	EXTRN	cursor_type:BYTE
	EXTRN	disable_macro:BYTE
	EXTRN	backslash_char:BYTE
	EXTRN	min_length:WORD
	EXTRN	msg_flag:BYTE
	EXTRN	cmdedit_disable:BYTE
	EXTRN	TAB_key_function:BYTE	; these three made BYTE by jmh
	EXTRN	ESC_key_function:BYTE
	EXTRN	BKS_key_function:BYTE	; added by wd

DGROUP	GROUP	CSEG


	ASSUME	CS:DGROUP,DS:DGROUP,ES:DGROUP,SS:DGROUP

; install_begin MUST be start of installation code.
install_begin	LABEL BYTE
copyrite     db SIGNATURE2,32,254,32,SIGNATURE3,CR,LF,SIGNATURE4,CR,LF
	     db SIGNATURE5,CR,LF,CR,LF,DOLLAR,26
msg_nomem    db '* Insufficient Memory - Reduce buffer sizes *',CR,LF,DOLLAR
option_error db '* Unknown or illegal options *',CR,LF,DOLLAR
file_error   db '* Error processing command file *',CR,LF,DOLLAR
IFNDEF NODIRS
dirstk_error db '* Error processing directory stack commands *',CR,LF,DOLLAR
ENDIF
inv_dosver   db '* Unsupported DOS version. *',CR,LF,DOLLAR
msg_dup      db '* CMDEDIT already installed in memory. *',CR,LF,DOLLAR
;dfa added options to next line:
options_dup  db '* Only options /a /c /g /i /l /n /o /p /r /t /z may be specified. *',CR,LF,DOLLAR
msg_notdup   db '* No copy of CMDEDIT found in memory. *',CR,LF,DOLLAR
msg_unload   db '* Unable to unload CMDEDIT.		*',CR,LF
	     db '* Uninstall TSRs in reverse order.	*',CR,LF,DOLLAR
msg_memerr   db '* DOS memory allocation error! *',CR,LF,BEL
	     db '* Recommend you reboot!        *',CR,LF,BEL,DOLLAR
msg_uninstalled db '* CMDEDIT uninstalled successfully *',CR,LF,DOLLAR
msg_omode    db '* Default overwrite mode enabled. *',CR,LF,DOLLAR
msg_imode    db '* Default insert mode enabled. *',CR,LF,DOLLAR
msg_enable_autorecall  db '* autorecall enabled. *',CR,LF,DOLLAR
msg_disable_autorecall db '* autorecall disabled. *',CR,LF,DOLLAR
msg_enable_bell  db '* error bell enabled. *',CR,LF,DOLLAR
msg_disable_bell db '* error bell disabled. *',CR,LF,DOLLAR
msg_ignore_char  db '* ignore character changed. *',CR,LF,DOLLAR
;following added by dfa
;(also removed the word "CMDEDIT" from begining of above 5 strings :
msg_dcursor_type   db '* default cursor types. *',CR,LF,DOLLAR
msg_scursor_type   db '* insert & overwrite cursors swapped. *',CR,LF,DOLLAR
msg_disable_macro  db '* macro translation disabled. *',CR,LF,DOLLAR
msg_disable_slash  db '* backslash appending disabled. *',CR,LF,DOLLAR
msg_enable_macro   db '* macro translation enabled. *',CR,LF,DOLLAR
msg_length_changed db '* changed minimum history line length. *',CR,LF,DOLLAR
msg_notinst db '* /o specified but CMDEDIT not previously installed. *',CR,LF,DOLLAR
msg_disable db '* CMDEDIT disabled. *',CR,LF,DOLLAR
msg_enable  db '* CMDEDIT enabled. *',CR,LF,DOLLAR

cmdedit_seg  dw	0				;Segment of the first copy
;						 of CMDEDIT loaded into memory.

macrosize	dw	512	;Default size of macro buffer
symsize		dw	512	;Default size of symbol buffer
dossize 	dw	512	;Default size of DOS history buffer
IFNDEF NODIRS
dirsize 	dw	128	;Default size of directory stack buffer
ENDIF

argflags	dw	0	;Used to remember what args have been seen.
				;dfa changed from db to dw to allow more args.
dosarg		equ	0001h	;(in most cases so can flag an error if trying
applarg 	equ	0002h	;  to change after installation)
filearg 	equ	0004h
IFNDEF NODIRS
dirarg		equ	0008h
ENDIF
macroarg	equ	0010h
symarg		equ	0020h
uninstall_arg	equ	0040h
ignore_arg	equ	0080h
;added by dfa:
length_arg	equ	0100h
not_inst_arg	equ	0200h
esc_arg 	equ	0400h
no_check_arg	equ	0800h
cycle_arg	equ	1000h
raw_arg 	equ	2000h

argument_buffer db	LINEBUF_SIZE DUP (?)

;	This location is jumped to when the program is run from the DOS
;	command line. The program parses the input line, takes
;	appropriate actions, initializes buffers etc. and then TSR's
;	after taking over interrupt 21h. The memory taken up by the ISEG
;	segment will then be used for various data buffers since this
;	code is no longer needed.
install proc	near
	cld			;Entire program assumes direction flag will
;				 be cleared

	ASSUME CS:DGROUP,DS:DGROUP,ES:DGROUP,SS:DGROUP
	@DispStr pgm_name		;Display program name
	@DispStr copyrite		;added by jmh

; Make sure we are running DOS 2.x or higher
	call	near ptr get_dosversion
	cmp	dos_version_major,1		;DOS 1.x ?
	jne	@install_1
	@DispStr inv_dosver
	mov	ax,-1
	jmp	abort_install			;V1.x not supported.

@install_1:
; Locate the segment of the first copy of CMDEDIT in memory so that
; we can tell if this is a second copy.
	call	near ptr locate_cmdedit
	mov	cmdedit_seg,ax			;Remember it

@install_5:
	mov	si,offset cmdlen ;
	lodsb			;SI == line in PSP, AL == line length
	mov	cl,al
	xor	ch,ch		;CX = line length
	xor	ax,ax		;Function = get argument count
	push	cx		;Save line length
	call 	near ptr getargs ;AX := # arguments in command line
	pop	cx		;Restore line length
	mov	di,ax		; DI == number of arguments
	inc	di		;Prime for loop
@install_10:
	dec	di		;Any more arguments ?
	jz	@install_20	;No
	mov	bx,offset DGROUP:argument_buffer
	mov	dx,SIZE argument_buffer
	mov	ax,di		;Argument number
	push	cx		;save line length
	call 	near ptr getargs ;Get argument into argument_buffer
;				  (no chance of buffer being too short)
	call 	near ptr process_args ;Process the argument
	pop	cx		;Restore line length
	jmp	short @install_10 ;loop back to process remaining args


@install_20:
; OK now we have done all necessary parsing without errors. Now first check
; if the uninstall option was specified.
	test	argflags,uninstall_arg
	je	@install_21		;Nope

; We have to unload a previously installed copy of CMDEDIT. See if it is
; really there.
	mov	ax,ds			;Are we the only copy of CMDEDIT ?
	cmp	ax,cmdedit_seg
	je	@install_20_a		;There is no other copy
	jmp	uninstall

@install_20_a:
	@DispStr msg_notdup		;Indicate no copy to uninstall
	mov	ax,-1
	jmp	abort_install		;Exit 

@install_21:
; No uninstall option specified. Now check if this is the only copy of
; CMDEDIT.
	test	argflags,no_check_arg  ;is checking disabled? (added by dfa)
	jnz	@install_21_a1
	mov	ax,ds
	cmp	ax,cmdedit_seg
	je	@install_21_a1		;We are the only copy. Proceed with
;					 installation 
	jmp	change_installed_options ;Else go change installed options.

@install_21_a1: 			;added by dfa
	mov	cmdedit_seg,ds		;in case /n specified.
	test	argflags,not_inst_arg	;Do we want to install or not?
	jz	@install_21_a
	@DispStr msg_notinst		;Indicate no copy installed to change.
	mov	ax,-1
	jmp	abort_install		;Exit

@install_21_a:
; At this point all the arguments have been parsed. Now check
; that the sum total of the various buffer sizes does not exceed
; segment limits. Also check for mandatory minimum sizes.
; Finally, transfer control to the resident portion which will
; relocate buffers to overlay the installation code.

	mov	ax,OFFSET DGROUP:install_begin
					;add starting address where buffers
					; will begin
	add	ax,STACK_SIZE
	jnc	@install_23
	jmp	@install_125
@install_23:
	cmp	macrosize,MACROSIZE_MIN
	jnb	@install_22
	mov	macrosize,MACROSIZE_MIN ;Ensure min buffer sizes
@install_22:
	add	ax,macrosize
	jc	@install_125
	cmp	symsize,SYMSIZE_MIN
	jnb	@install_24
	mov	symsize,SYMSIZE_MIN ;Ensure min buffer sizes
@install_24:
	add	ax,symsize
	jc	@install_125
	cmp	dossize,DOSSIZE_MIN
	jnb	@install_26
	mov	dossize,DOSSIZE_MIN ;Ensure min buffer sizes
@install_26:
	add	ax,dossize
	jc	@install_125
IFNDEF NODIRS
	cmp	dirsize,DIRSIZE_MIN
	jnb	@install_30
	mov	dirsize,DIRSIZE_MIN ;Ensure min buffer sizes
@install_30:
	add	ax,dirsize
	jc	@install_125
ENDIF
;Enough memory, so keep resident. Install our Ctrl-Break handler.
	push	es			;Save ES
	mov	ah,35h
	mov	al,1bh			;Ctrl-Break Interrupt
	int	21h			;Get current handler address
	mov	CS:prev_isr1b,bx	;Offset of previous handler
	mov	CS:prev_isr1b+2,es	;Segment of previous handler
	pop	es			;Restore es
	mov	dx,offset CS:our_break_handler
	push	ds			;Save DS
	mov	ax,cs
	mov	ds,ax			;DS:DX->our break handler
	mov	al,1bh
	mov	ah,25h			;Set up our break handler
	int	21h
	pop	ds			;Restore DS
;
;Install out switcher multiplex handler.
	push	es
	mov	ah,35h
	mov	al,2fh			;Multiplex Interrupt
	int	21h
	mov	CS:prev_isr2f,bx
	mov	CS:prev_isr2f+2,es
	pop	es
	mov	dx,offset CS:our_mpx_handler
	push	ds
	mov	ax,cs
	mov	ds,ax
	mov	al,2fh
	mov	ah,25h
	int	21h
	pop	ds
;
	jmp	near ptr init_over



@install_125:
	@DispStr msg_nomem
	mov	ax,-1
	jmp	abort_install

install endp




;+
; FUNCTION : process_args
;
;	Processes the argument pointed to by BX. AX contains length 
;	of argument. If a previously seen argument is repeated, it is
;	ignored (ie. the old value is kept). Note that the argument is
;	assumed not to contain any delimiters (like space or tab).
;
;	Options start with either a '-' or '/'. Any associated value must
;	follow immediately after without any intervening space/tab.
;		/f	Macro file to be read.
;		/l	(added by dfa) min. command length to store in buffer
;		/d	DOS history buffer size
;		(/a)	Application history buffer size (only if
;			separate histories maintained) (OUTDATED)
;		/a	(added by dfa) Now a toggle for backslash appending
;		/m	Macro buffer size
;		/b	symbol buffer size
;		/s	Directory Stack size
;		/r	Auto recall mode
;		/i	Insert mode default
;		/c	(added by dfa) Reverse cursor type for insert/overtype
;		/k	(added by dfa) ESC key also used for filenme completion
;		/t	(added by dfa) Disable macro and symbol translation
;		/g	Silent mode
;		/p	macro ignore character
;		(/e)	Enable dir commands all the time (OUTDATED)
;		/u	Uninstall CMDEDIT
;		/x	use raw read mode for keystrokes
;		/y	tab cYcles through matching files (swapped with Ctrl-\)
;
;
;	Invalid options result in program abortion. If an option is not
;	followed by a value, the default value for the option is assumed.
;
;	Note that this is NOT a general purpose getopt type routine.
;
; Parameters:
;	BX	= Pointer to argument
;	AX	= Number of characters in argument
;
; Returns:
;	Nothing.
;	Various globals may be set according to the specified argument.
; Register(s) BX (call to aton),CX  are destroyed.
;-
process_args proc near
	@save	si,di
	test	argflags,uninstall_arg
	jne	@process_args_5	;If /U specified, no other arg is allowed

	xchg	ax,cx		;CX = character count
	sub	cx,2		;Delete switch char and option letter
	jb	@process_args_5	;Error in option specification
				;  if num chars less than 2
	mov	si,bx		;SI = arg buffer address
	lodsb			;AL = first character
	cmp	al,'/'		;Should be either '/'
	je	@process_args_10 ;
	cmp	al,'-'		; or '-'
	jne	short @process_args_5	;Else error

@process_args_10:			;Saw a valid switch char
	lodsb				;AL = option letter
	or	al,32			;Lowercase (non alphabetic will be
					; ignored anyway)
	cmp	al,'u'			;Uninstall option ?
	jne	@process_args_13	;No
	or	cx,cx			;Ok if no more chars in arg
	jne	short @process_args_5	;Else error

@process_args_11:
	or	argflags,uninstall_arg	;Indicate /U seen
	jmp	@process_args_50	;Return

; process_args_13 added by dfa
@process_args_13:
	cmp	al,'c'			;swap cursor types option ?
	jne	@process_args_13b	;No
	jcxz	@process_args_13_a	;Ok if no more chars in arg
	jmp	short @process_args_5	;Else error
@process_args_13_a:
	mov	cursor_type,1		;Swap insert/overtype cursor mode
	jmp	@process_args_50	;Return

@process_args_13b:
	cmp	al,'k'			;Use ESC key for filename completion
;					 (as well as TAB)
	jne	@process_args_11_a	;No
	jcxz	@process_args_13b_a	;Ok if no more chars in arg
	jmp	short @process_args_5	;Else error
@process_args_13b_a:
	mov	al,BKS_key_function
	mov	ESC_key_function,al	;Make ESC do same as Ctrl-\
	or	argflags,esc_arg	;Remember we've seen this option
	jmp	@process_args_50	;Return

@process_args_11_a:
	cmp	al,'i'			;insert mode option ?
	jne	@process_args_14	;No
	jcxz	@process_args_12	;Ok if no more chars in arg
@process_args_5:
; Error processing
	@DispStr option_error
	mov	ax,-1
	jmp	abort_install
@process_args_12:
	mov	default_imode,1		;Change default insrt mode
	jmp	@process_args_50	;Return

@process_args_14:
	cmp	al,'g'			;silent mode option ?
	jne	@process_args_15	;No
	jcxz	@process_args_14_a	;Ok if no more chars in arg
	jmp	short @process_args_5	;Else error
@process_args_14_a:
	mov	silent,1		;Silent mode
	jmp	@process_args_50	;Return
@process_args_15:
	cmp	al,'r'			;auto-recall option ?
	jne	@process_args_18	;No
	jcxz	@process_args_16	;Ok if no more chars in arg
	jmp	short @process_args_5	;Else error
@process_args_16:
	mov	auto_recall,1		;Set auto-recall mode
	jmp	@process_args_50	;Return
@process_args_18:
IFNDEF NODIRS
	cmp	al,'e'			;Enable dir commands option?
	jne	@process_args_18_b	;No
	jcxz	@process_args_18_a	;OK if no more chars
	jmp	short @process_args_5	;Else error
@process_args_18_a:
	mov	enable_dircmds,1	;enable directory commands
	jmp	@process_args_50	;Return
ENDIF
@process_args_18_b:
	cmp	al,'p'			;ignore character option
	jne	@process_args_18_c
	cmp	cx,1			;Should be only one more char
	jne	@process_args_5		;Error
	lodsb
	or	argflags,ignore_arg	;Indicate that an ignore char set
	mov	macro_ignore_char,al
	jmp	@process_args_50	;Return
@process_args_18_c:			;added by dfa
	cmp	al,'t'			;disable macro and symbol translation
	jne	@process_args_18_e
	jcxz	@process_args_18_d	;OK if no more chars
	jmp	short @process_args_5	;Else error
@process_args_18_d:			;added by dfa
	mov	disable_macro,1 	;disable
					;will toggle option later if installed
	jmp	@process_args_50	;Return
@process_args_18_e:			;added by dfa
	cmp	al,'w'			;alternate error message display
	jne	@process_args_18_g
	jcxz	@process_args_18_f	;OK if no more chars
	jmp	short @process_args_5	;Else error
@process_args_18_f:			;added by dfa
	mov	msg_flag,1		;disable
;					 will toggle option later if installed
	jmp	@process_args_50	;Return
@process_args_18_g:			;added by dfa
	cmp	al,'o'			;do not install
	jne	@process_args_18_i
	jcxz	@process_args_18_h	;OK if no more chars
	jmp	@process_args_5 	;Else error
@process_args_18_h:			;added by dfa
	or	argflags,not_inst_arg
	jmp	@process_args_50	;Return
@process_args_18_i:			;added by dfa
	cmp	al,'z'			;disable CMDEDIT
	jne	@process_args_18_k
	jcxz	@process_args_18_j	;OK if no more chars
	jmp	@process_args_5 	;Else error
@process_args_18_j:			;added by dfa
	mov	cmdedit_disable,1; (will toggle option later if installed)
	jmp	@process_args_50	;Return
@process_args_18_k:			;added by dfa
	cmp	al,'n'			;disable CMDEDIT
	jne	@process_args_18_m
	jcxz	@process_args_18_l	;OK if no more chars
	jmp	@process_args_5 	;Else error
@process_args_18_l:			;added by dfa
	or	argflags,no_check_arg
	jmp	@process_args_50	;Return
@process_args_18_m:			;added by dfa
	cmp	al,'a'			;disable backslash appending
	jne	@process_args_18_o
	jcxz	@process_args_18_n	;OK if no more chars
	jmp	@process_args_5 	;Else error
@process_args_18_n:			;added by dfa & wd
	mov	backslash_char,0
	jmp	@process_args_50	;Return
@process_args_18_o:			;added by wd
	cmp	al,'y'			;cYcle filename completion on TAB
	jne	@process_args_18_q
	jcxz	@process_args_18_p	;OK if no more chars
	jmp	@process_args_5 	;Else error
@process_args_18_p:
	mov	ah,BKS_key_function	;Swap TAB and Ctrl-\
	mov	al,TAB_key_function
	mov	BKS_key_function,al
	mov	TAB_key_function,ah
	or	argflags,cycle_arg	;Remember we've seen this option
	test	argflags,esc_arg	;was /k specified?
	jz	@to_process_args_50	;no
	mov	ESC_key_function,al	;yes, set ESC key also
	jmp	@process_args_50	;Return
@process_args_18_q:			;added by wd
	cmp	al,'x'			;raw input mode
	jne	@process_args_19
	jcxz	@process_args_18_r	;OK if no more chars
	jmp	@process_args_5 	;Else error
@process_args_18_r:
	mov	getkey_funcnum,7	;use raw input for getkey call
        or      argflags,raw_arg        ;Remember we've seen this option
	jmp	@process_args_50	;Return

@process_args_19:
	cmp	al,'f'			;Is it the macro file option ?
	jne	@process_args_20
	test	argflags,filearg	;Already seen file argument ?
	je	@process_args_19_a	;No, then update
	jmp	@process_args_50	;Yes, then don't update
@process_args_19_a:
	or	argflags,filearg	;Remember we've seen this option
;	jcxz	@process_args_50	;(changed to the line below wd)
	jcxz	@to_process_args_50
	cmp	cx,63			;Max path length must be < 64
	jna	@process_args_19_b	;dfa changed ja @process_args_5 to
;					 these 3 lines.
	jmp	@process_args_5 	;Error
@process_args_19_b:
	mov	di,offset mfilename	;Temp storage for filename
	rep	movsb			;Copy file name
	mov	byte ptr [di],0		;Terminate with a NULL char
	mov	mfile_seen,1		;Indicate that init file specified
@to_process_args_50:
	jmp	@process_args_50	;(dfa): was a short jump
@process_args_20:
	push	ax			;Save the option letter
	xchg	ax,cx			;AX = num of char
	call	near ptr aton		;All other options are numeric values
	jnc	@process_args_22	;No Errors
	jmp	@process_args_5 	;Error
@process_args_22:
;AX contains numeric value
	xchg	ax,cx			;CX = numeric value
	pop	ax			;Restore option letter

;next 7 lines added by dfa
	cmp	al,'l'			;Is it the minimum length option ?
	jne	@process_args_24
	test	argflags,length_arg	;Already seen argument ?
	jne	@process_args_50	;Yes, then don't update
	or	argflags,length_arg	;Remember we've seen this option
	mov	min_length,cx
	jmp	short @process_args_50

@process_args_24:
	cmp	al,'d'			;Is it the dos history size option ?
	jne	@process_args_25
	test	argflags,dosarg 	;Already seen argument ?
	jne	@process_args_50	;Yes, then don't update
	or	argflags,dosarg 	;Remember we've seen this option
	mov	dossize,cx
	jmp	short @process_args_50

@process_args_25:
	cmp	al,'m'			;Is it the macro buf size option ?
	jne	@process_args_35
	test	argflags,macroarg	;Already seen argument ?
	jne	@process_args_50	;Yes, then don't update
	or	argflags,macroarg	;Remember we've seen this option
	mov	macrosize,cx
	jmp	short @process_args_50

@process_args_35:
	cmp	al,'b'			;Is it the symbol buf size option ?
	jne	@process_args_40
	test	argflags,symarg 	;Already seen argument ?
	jne	@process_args_50	;Yes, then don't update
	or	argflags,symarg 	;Remember we've seen this option
	mov	symsize,cx
	jmp	short @process_args_50

@process_args_40:
IFNDEF NODIRS
	cmp	al,'s'			;Is it the dir stack option ?
	je	@process_args_55	;Yes
ENDIF
	jmp	@process_args_5 	;Invalid arg
IFNDEF NODIRS
@process_args_55:
	test	argflags,dirarg 	;Already seen argument ?
	jne	@process_args_50	;Yes, then don't update
	or	argflags,dirarg 	;Remember we've seen this option
	mov	dirsize,cx
ENDIF
@process_args_50:

	@restore
	ret
process_args endp


;+
; FUNCTION : aton
;
;	Returns the positive integer value of an ASCII string. The value
;	must be between 0 and 65535. If length of string is 0, then a 0
;	value is returned with no error flags.
;
; Parameters:
;	SI	:= address of first character in string
;	AX	:= count of characters
;
; Returns:
;	AX = 16 bit result if no errors.
;	CF = 1 if error (magnitude too large, invalid character etc.)
;	     0 if no errors.
; Register(s) CX,DX  are destroyed.
;-
aton	proc	near
	@save	si,di
	xor	di,di		;Result
	xchg	ax,cx		;CX <- num of chars
	jcxz	@aton_99	;No chars, result = 0 (CF is also 0)
	cmp	cx,6		;Shouldn't be more'n 5 chars
	cmc			;CF=1 if error
	jb	@aton_99	;Error exit
@aton_10:
	lodsb			;al = char
	sub	al,'0'		;Is ASCII value < '0'
	jb	@aton_99
	mov	dx,9		;Comparison with 9, NOT '9'
	cmp	dl,al
	jb	@aton_99	;Not valid char
	xor	ah,ah
	inc	dx		;DX = 10 (multiplier)
	xchg	ax,di		;ax = result so far
	mul	dx		;Multiply by 10
	jb	@aton_99	;Overflow
	add	ax,di		;Add new character
	jb	@aton_99	;Overflow
	xchg	ax,di		;Remember new result in di
	loop	@aton_10	;Go onto next char
@aton_99:
	xchg	ax,di
	@restore
	ret
aton	endp


;+
; FUNCTION : get_dosversion
;
;
; Stores DOS major and minor versions in dos_version_major and
; dos_version_minor.
;-
get_dosversion proc near
	mov	ah,30h
	int	21h
	mov	dos_version_major,al
	mov	dos_version_minor,ah
	ret
get_dosversion endp




;+
; FUNCTION : abort_install
;
;	Called to abort program before installation. Exits to DOS.
;
; Parameters:
;	AL	= Exit code
;
; Returns:
;	Nothing.
;
; Register(s) destroyed:
;	N/A
;-
abort_install proc near
	@Exit
abort_install endp



;+
; FUNCTION : locate_cmdedit
;
;	Called to locate the first copy of CMDEDIT loaded into memory. This
;	is not foolproof in that if CMDEDIT is loaded into high memory
;	using one of the memory managers like QEMM, it will not be found.
;
; Parameters:
;	None.
;
; Returns:
;	AX - segment of first copy of CMDEDIT in memory.
;
; Register(s) destroyed:
;	<TBA>
;-
locate_cmdedit proc near
	mov pgm_name, 99 ; Changes first letter 'C' to 'c' so differs from any
			 ; copy which may also be in memory due to disk caching
			 ; or something similar.  Added by dfa.
	@save	si,di,es
;	mov	di,offset DGROUP:cmdedit	;SI and DI will used for
;Line above replaced by dfa to line below so can change signature in
;running versions.
	mov	di,offset DGROUP:pgm_name	;SI and DI will used for
	mov	si,di				;comparisons
	mov	ax,0A000H			;AX will track segments
						;changed from 0 to A000 by jmh
@locate_cmdedit_5:
	mov	es,ax
	push	si				;Save offsets that are
;						 compared 
	mov	cx,32				;Count to be matched
	repe	cmpsb				;rep -> repe by jmh
	pop	si				;Restore offsets that are
;						 compared 
	je	@locate_cmdedit_50		;Matched
	mov	di,si
	inc	ax
	jmp	short @locate_cmdedit_5		;Try next segment

@locate_cmdedit_50:

	@restore
	ret
locate_cmdedit endp


;+
; FUNCTION : uninstall
;
;	Called to uninstall a previously loaded copy of CMDEDIT.
;	The routine does not return. It exits CMDEDIT.
;
; Parameters:
;	None.
;
; Returns:
;	None.
;
; Register(s) destroyed:
;	<TBA>
;-
uninstall proc near
; Free up the memory occupied by the previous loaded copy of CMDEDIT.
; First give back the all interrupts that were taken over.

; Make sure no one else has taken over the 1b break handler since we
; took it over.
	mov	ax,351bh		;Retrieve current 1b handler
	int	21h
	cmp	bx,offset our_break_handler ;Is the offset the ours ?
	je	@uninstall_20		;Yes
@uninstall_10:
; Someone else's taken over the interrupt. Display message and exit.
	@DispStr msg_unload
	mov	ax,-1
	jmp	abort_install
@uninstall_20:
	mov	ax,es			;Now compare segment
	cmp	ax,cmdedit_seg		;Is it what we expect?
	jne	@uninstall_10		;No, display error

; Test the int 2fh handler.
	mov	ax,352fh		;Retrieve current 2f handler
	int	21h
	cmp	bx,offset our_mpx_handler ;Is the offset the ours ?
	jne	@uninstall_10		;No, error
	mov	ax,es			;Now compare segment
	cmp	ax,cmdedit_seg		;Is it what we expect?
	jne	@uninstall_10		;No, display error

; Now check the int 21h handler.
	mov	ax,3521h		;Retrieve current 21 handler
	int	21h
	cmp	bx,offset cmdedit_isr	;Is the offset the ours ?
	jne	@uninstall_10		;No, error
	mov	ax,es			;Now compare segment
	cmp	ax,cmdedit_seg		;Is it what we expect?
	jne	@uninstall_10		;No, display error

; OK, now restore all interrupts
	mov	es,cmdedit_seg		;ES<-segment of loaded CMDEDIT
	mov	dx,es:prev_isr1b	;DS:DX->original 1b handler
	mov	ds,es:prev_isr1b+2
	mov	ax,251bh		;Return int 1b
	int	21h

	mov	dx,es:prev_isr2f	;DS:DX->original 2f handler
	mov	ds,es:prev_isr2f+2
	mov	ax,252fh		;Return int 2f
	int	21h

	mov	dx,es:old_int21vec	;DS:DX->original int 21h handler
	mov	ds,es:old_int21vec+2
	mov	ax,2521h		;Return int 21
	int	21h

	push	cs
	pop	ds			;Restore DS
;
; Finally, return the block of memory taken up by the previous CMDEDIT copy.
	mov	ah,49h			;Release block function, ES->segment
	int	21h			;Free the block
	jnc	@uninstall_90		;No errors
	@DispStr msg_memerr		;Memory allocation error !
	mov	ax,-1
	jmp	abort_install

@uninstall_90:
	@DispStr msg_uninstalled
	xor	ax,ax

	@Exit	0			;Exit to DOS

uninstall endp


;+
; FUNCTION : change_installed_options
;
;	Called to change settings on a previously installed copy of
;	CMDEDIT. The function exits to DOS.
;
;	This function allows the following options to be toggled or
;	changed:
;		/r - toggles autorecall mode
;		/i - toggles insert mode
;		/g - toggles silent mode
;		/p - sets a new ignore character
;following added by dfa:
;	/c - swaps cursor type used for insert & overtype modes.
;	/w - alternate error message display
;	/l - sets the minimum command line size stored in history buffer
;	/t - toggles macro and symbol translation off/on
;	/z - toggles CMDEDIT disable
;	/y - toggles the tab key's match cYcling (added by wd)
;
;If any other option (except /n or /o) is specified, error message is displayed.
;	
; Parameters:
;	None.
;
; Returns:
;	Nothing.
;
; Register(s) destroyed:
;	<TBA>
;-

change_installed_options proc near
	@DispStr msg_dup
	mov	ax,argflags	;(dfa): was al here, but argflags is now a WORD
				;(dfa) added length_arg and not_inst_arg
	and	ax,NOT (ignore_arg + length_arg + not_inst_arg)
	je	@change_installed_options_10
; Unallowed options specified.
	@DispStr options_dup
	mov	ax,-1
	jmp	abort_install

@change_installed_options_10:
	@DispCh LF
; Change the options specified.
	mov	es,cmdedit_seg		;ES->segment of previously loaded
;					 CMDEDIT 
; First toggle the insert mode option. If /i specified, default_imode will
; be 1, else 0. Thus just xor it with the memory resident copy to toggle
; default mode.
	mov	al,es:default_imode
	xor	al,default_imode	
	mov	es:default_imode,al	;Toggle memory resident option
	or	al,al
	je	@change_installed_options_15
	@DispStr msg_imode
	jmp	short @change_installed_options_17
@change_installed_options_15:
	@DispStr msg_omode

@change_installed_options_17:
;Cursor type toggle (added by dfa)
	mov	al,es:cursor_type
	xor	al,cursor_type
	mov	es:cursor_type,al	;Toggle memory resident option
	or	al,al
	je	@change_installed_options_18
	@DispStr msg_scursor_type
	jmp short @change_installed_options_19
@change_installed_options_18:
	@DispStr msg_dcursor_type

@change_installed_options_19:
;Disable backslash toggle (added by dfa & wd)
	mov	al,backslash_char
	xor	al,'\'
	xor	al,es:backslash_char
	mov	es:backslash_char,al	;Toggle memory resident option
	or	al,al
	jnz 	short @change_installed_options_20
	@DispStr msg_disable_slash

@change_installed_options_20:
	mov	al,es:auto_recall
	xor	al,auto_recall
	mov	es:auto_recall,al	;Toggle memory resident option
	or	al,al
	jne	@change_installed_options_25
	@DispStr msg_disable_autorecall
	jmp	short @change_installed_options_30
@change_installed_options_25:
	@DispStr msg_enable_autorecall

@change_installed_options_30:
; And now for silent mode
	mov	al,es:silent
	xor	al,silent
	mov	es:silent,al	;Toggle memory resident option
	or	al,al
	je	@change_installed_options_35
	@DispStr msg_disable_bell
	jmp	short @change_installed_options_40
@change_installed_options_35:
	@DispStr msg_enable_bell

@change_installed_options_40:

; Change the ignore character if one was specified.
	test	argflags,ignore_arg
	je	@change_installed_options_50	;None specified
; Change to the new macro ignore char
	mov	al,macro_ignore_char
	mov	es:macro_ignore_char,al
	@DispStr msg_ignore_char

@change_installed_options_50:
; And now for macro translation toggle
	mov	al,es:disable_macro
	xor	al,disable_macro
	mov	es:disable_macro,al		;Toggle memory resident option
	or	al,al
	je	@change_installed_options_55
	@DispStr msg_disable_macro
	jmp	short @change_installed_options_57
@change_installed_options_55:
	@DispStr msg_enable_macro

@change_installed_options_57:
; alternative error message display
	mov	al,es:msg_flag
	xor	al,msg_flag
	mov	es:msg_flag,al		;Toggle memory resident option
	or	al,al
				;not really necessary to confirm this switch.

@change_installed_options_60:
; And now for minimum line length option if one was specified.
	test	argflags,length_arg
	je	@change_installed_options_70	;None specified
	mov	ax,min_length
	cmp	ax,es:min_length		;Is new value different to old?
	je	@change_installed_options_70	;no
	mov	es:min_length,ax		;Change memory resident value
	@DispStr msg_length_changed

@change_installed_options_70:
; And now for disable CMDEDIT toggle
	mov	al,es:cmdedit_disable
	xor	al,cmdedit_disable
	mov	es:cmdedit_disable,al		;Toggle memory resident option
	or	al,al
	je	@change_installed_options_75
	@DispStr msg_disable
	jmp	short @change_installed_options_90
@change_installed_options_75:
	@DispStr msg_enable

@change_installed_options_90:
; All done
	@Exit	0

change_installed_options endp



;+ FUNCTION : getargs
;
;	getargs does one of two functions depending on the value in AX.
;	If AX = 0, returns count of arguments in the line,
;	else if AX = n, returns the nth argument.
;
;	The argument separators are tab and space. Note that a
;	carraige return (0Dh) terminates a line even if the byte
;	count indicates otherwise.  Arguments containing a SPACE or
;	TAB separator may be specified by enclosing them in a pair of
;	quotes ("). The quotes do NOT act as argument delimiters. For
;	example the following line
;		this"is a single "arg
;	contains exactly one argument. An unmatched quote causes the
;	remaining characters in the line to be treated as a single
;	argument. A quote character can be included as part of an
;	argument by preceding it with a ESCARG character. An ESCARG preceding
;	any other character does not have any special meaning.
;	  Note that all other characters including the NUL char (00h)
;	have no special significance.
;
; Parameters:
;	DS:SI points to the line
;	AX = argument number n
;	CX = Length of line
;	If parameter n != 0,
;	then BX = address of user buffer where the returned argument is to
;		be stored. This param need not be present if n is 0.
;	     DX = length of user buffer.
;
;
; Returns:
;	If parameter n was 0,
;		return argument count in AX (CF is undefined),
;	else
;		Store n'th argument in the buffer pointed to by BX and
;		return the number of chars in the argument in AX.
;		The returned argument has quotes and ESCARGes stripped
;		out where appropriate. If the buffer is too small, CF
;		is set to 1, else it is 0. In this case the user buffer
;		contents are undefined.
;	BX is explicitly unchanged.
;
; Registers CX,DX are destroyed.
;-
getargs	proc	near
ESCARG	EQU	PERCENT
	@save	si,di
	push	bp
	mov	bp,sp
	sub	sp,2
userbuf_len EQU <word ptr [bp-2]>
	mov	di,ax		;save argument number

	xor	ax,ax		;al will hold char, ah will hold state
	mov	userbuf_len,dx	;Save size of user buffer
	xor	dx,dx		;dx counts arguments
				;CX = line length
	or	cx,cx		;Check if CX is 0 (jump too far for jcxz)
	jne	@getargs_2
	jmp	@getargs_99	;0 length, jump around ajnup
@getargs_2:
;	At the start of this loop, the following hold :
;	(1) CX >= 1. CX holds count of remaining characters.
;	(2) ah holds the current "state" with the following encoding -
;		When Bit 1 is 0, bit 0=0 indicates we're outside an argument
;		and bit0=1 indicates we are inside an arg.
;		When Bit 1 is 1, we are inside a quoted argument. In this
;		case, bit 0 "remembers" the state we were in before the
;		quotes so that it can be restored upon reaching the closing
;		quotes.
;		Bit 2 remembers if prev char was a ESCARG (=1) or not (=0)
;		Bit 3 = 1 indicates this argument is to be copied into the
;			  user buffer

in_arg		equ	01h
in_quote 	equ	02h
saw_ESCARG	equ	04h
	lodsb				;Get next char
	cmp	al,CR			;If carraige-return
	je	@getargs_50		;  then terminate processing.
	call	near ptr isspace	;Check if space or tab
	jne	@getargs_10		;No, jump
;	Process separator
	and	ah,NOT saw_ESCARG ;Remember char is not a ESCARG
	test	ah,in_quote	;Are we inside quotes ?
	jnz	@getargs_49		;If so go onto next char
	and	ah,NOT in_arg	;else reset the inside arg flag
	jmp	short @getargs_49	;and go onto next char


@getargs_10:			;Not a separator
	test	ah,in_arg OR in_quote ;Were we inside an arg or quoted arg ?
	jnz	@getargs_11		;Yes, then skip the increment
				;else entering an arg, so
	inc	dx		;	increment arg count
	or	di,di		;	If function is return arg count
	je	@getargs_11		;	then go on
	cmp	di,dx		;	else check if this is the arg we want
	jne	@getargs_11		;	Nope, keep on
				;	Yep, this be the one
	mov	di,bx		;di = destination buf, ES assumed = DS
	xor	dx,dx		;Zero the character count
	jmp	short @getargs_80	;Go to the copy loop
@getargs_11:
	cmp	al,QUOTE	;Is this a quote ?
	jne	@getargs_15		;No, normal processing
	test	ah,saw_ESCARG	;Found quote, was prev char a ESCARG ?
	jnz	@getargs_15		;Yes, normal processing
	xor	ah,in_quote	;else toggle the quote flag
	jmp	short @getargs_49	;go onto next char
@getargs_15:			;Normal processing
	and	ah,NOT saw_ESCARG ;assume char is not a ESCARG
	cmp	al,ESCARG	;Is this a ESCARG ?
	jnz	@getargs_20		;No
	or	ah,saw_ESCARG	;Set ESCARG flag
@getargs_20:
	test	ah,in_quote	;Are we inside quotes ?
	jnz	@getargs_49		;If so go onto next char
	or	ah,in_arg	;else set the inside arg flag

@getargs_49:
	loop	@getargs_2		;Go onto next char if any

@getargs_50:			;Finished with the line
	or	di,di		;Were we supposed to return an argument ?
	je	@getargs_99		;No, so go on
	xor	dx,dx		;Yes, but arg num was > number of args
				; so return a 0 count
	jmp	short @getargs_99	;Skip over copy arg section



;Copy argument loop begins.

@getargs_70:
	lodsb				;Get next char
	cmp	al,CR			;If carraige-return
	je	@getargs_99		;  then terminate processing.

	call	near ptr isspace	;Check if space or tab
	jne	@getargs_80		;No, jump

;	Process separator
	test	ah,in_quote	;Are we inside quotes ?
	jz	@getargs_99		;No, terminate processing
	jmp	short @getargs_85	;Treat like any other char

@getargs_80:			;Not a separator
	;At this point CX = num of bytes remaining in the line including the
	;one in AL.

	cmp	al,QUOTE	;Is this a quote ?
	jne	@getargs_85		;No, normal processing
	test	ah,saw_ESCARG	;Found quote, was prev char a ESCARG ?
	jnz	@getargs_84		;Yes, jump
	xor	ah,in_quote	;else toggle the quote flag
	jmp	short @getargs_89	;go onto next char

@getargs_84:			;Found a \" combination
	dec	di		;Previous \ shouldn't have been written
	dec	dx		;or counted.
				;fall thru for normal processing

@getargs_85:			;Normal processing
	sub	userbuf_len,1	;Decrement space remaining in buffer. Do
;				 NOT use DEC here since CF needs to be set
	jb	@getargs_100	;No more space, exit with CF set
	stosb			;Store the char
	inc	dx		;and incr count

	and	ah,NOT saw_ESCARG ;assume char is not a ESCARG
	cmp	al,ESCARG	;Is this a ESCARG ?
	jnz	@getargs_89	;No
	or	ah,saw_ESCARG	;Set ESCARG flag

@getargs_89:
	loop	@getargs_70	;Go onto next char if any

@getargs_99:
	xchg	ax,dx		;AX<-arg count or num chars in returned arg
	clc			;Clear CF for no error
@getargs_100:
	mov	sp,bp
	pop	bp
	@restore
	ret
getargs	endp


; Let's assume the user will never allocate more than 4K for the buffers. This
; allows us to free quite a few bytes in memory, but at the expense of bloating
; the executable (but with cluster sizes as they are, it hardly matters).
	IF	($ - install_begin) LT 4096
	db	4096 - ($ - install_begin) dup (?)
	ENDIF


;+
; FUNCTION : read_cmdfile
;
;	Reads commands from a file. The filename is in the variable
;	mfilename.
;
; Parameters:
;	None.
;
; Returns:
;	AX =	0 on success, any other value if failure
;
; Register(s) destroyed:
;	AX,BX,CX,DX
;-
read_cmdfile proc near
	@save	si,di
	cmp	mfile_seen,0
	je	@read_cmdfile_100	;No file specified

	@OpenFil mfilename,0
	jc	@read_cmdfile_92	;CF=1 for errors
@read_cmdfile_30:
	mov	source,offset DGROUP:get_file_line
;					We want get_next_line to read
;					from the file.
	mov	mfile_handle,ax		;Save file handle

@read_cmdfile_50:
	mov	dx,offset DGROUP:linebuf ;Destination for file line
	mov	ax,LINEBUF_SIZE
	call	near ptr freadline	;Get next line into buffer
					;AX contains line length
	jnc	@read_cmdfile_80	;no error or EOF
	or	ax,ax			;No more bytes ?
	jz	@read_cmdfile_99	;EOF is not error
	jmp	short @read_cmdfile_90	;Error, abort install
@read_cmdfile_80:
	mov	dx,offset DGROUP:linebuf
	add	dx,ax
	mov	lastchar,dx		;Update end of line
	call	near ptr cmdedit_cmd	;Execute as a command
	jnc	@read_cmdfile_50	;If not a command, better be a
;					 blank line
	call	near ptr blankline
	jnc	@read_cmdfile_50	;Ignore blank lines
; 	If not blank line and not CMDEDIT command, then error error handler

@read_cmdfile_90:
; Come here for error
	@ClosFil mfile_handle		;Close the file
@read_cmdfile_92:
	@DispStr file_error
	mov	ax,-1			;Indicate exit code
	jmp	abort_install		;Exit program

@read_cmdfile_99:
	@ClosFil mfile_handle		;Close the file
	jc	@read_cmdfile_92	;Abort if error closnig file
@read_cmdfile_100:
	@restore
	ret
read_cmdfile endp



;+
; FUNCTION : get_file_line
;
;	Called indirectly through the global variable 'source'.
;	Currently this routine exists only during installation and must
;	NOT be called once the program is a TSR. The next line from the
;	file is copied to linebuf. If there is no next line, the
;	installation is aborted.
;
; Parameters:
;	None.
;
; Returns:
;	Nothing.
; Register(s) destroyed:
;	AX,BX,CX,DX
;-
get_file_line proc near
	mov	dx,offset DGROUP:linebuf
	mov	ax,LINEBUF_SIZE
	call	near ptr freadline
	jnc	@get_file_line_99
;Error reading file or EOF
	@DispStr file_error
	jmp	abort_install
@get_file_line_99:
	mov	dx,offset DGROUP:linebuf
	add	dx,ax
	mov	lastchar,dx		;Update end of line
	ret
get_file_line	endp




;+
; FUNCTION : freadline
;
;	Reads a line at a time from the file whose handle is in
;	mfile_handle into the buffer pointed to by AX. If the buffer is
;	too small or if there are any errors, the routine returns with CF set.
;	If EOF, then AX = 0 and CF is set.
;
; Parameters:
;	DX	= address of buffer
; 	AX	= size of buffer
;
; Returns:
;	CF 	= 0 if no errors (and not EOF), else 1.
;	AX	= num chars in line if CF = 0.
;		  0 if EOF, ffff for other errors if CF = 1
;
; Register(s) destroyed:
;-
freadline proc	near
	@save	si,di
	mov	di,dx			;DI->buffer
	mov	bx,mfile_handle
	mov	si,ax			;SI<-num bytes to read
	xchg	cx,ax			;CX<-num bytes to read
	mov	ah,3Fh			;File read function
	int	21h
	jc	@freadline_99		;Error!
	mov	cx,ax			;CX<-num bytes read
	jcxz	@freadline_99_a		;EOF (note AX is 0 indicating EOF)
	xchg	dx,ax			;DX<-num bytes read
	mov	bx,di			;BX->start of buffer
	mov	al,CR
	repne	scasb			;Hunt for CR
	je	@freadline_50		;Found
;	No CR found, this better be the last line in file.
	cmp	dx,si			;Were fewer bytes read than requested?
	cmc
	jc	@freadline_99		;Error
	push	dx			;Save length of line
	xor	ax,ax			;AX<-num extra bytes read
	jmp	short @freadline_60
@freadline_50:
	stc				;Assume line too long
	jcxz	@freadline_99		;error if match in last char
;					 (line too long)
	cmp	BYTE PTR [di],LF	;Next char must be linefeed
	stc				;Assume error
	jne	@freadline_99		;Indeed an error if not LF
	mov	ax,di
	sub	ax,bx			;AX<-num chars including CR
	sub	dx,ax
	xchg	ax,dx
	dec	dx			;DX<-num chars in line
	dec	ax			;AX<-num extra chars read
	push	dx			;Save num chars in line

@freadline_60:
; Top of stack contains num bytes in line.
; Now position file pointer to 'unread' characters.
; AX contains the num of extra characters read.
	neg	ax
	cwd
	mov	cx,ax
	xchg	cx,dx			;CX:DX<-num bytes to 'unread'
	mov	bx,mfile_handle
	mov	ax,4201h		;Move file ptr relative
	int	21h			;Seek file relative
; CF set/reset by error status
	pop	ax			;AX<-num bytes in line
	clc				;No errors
	jmp	short @freadline_100
@freadline_99:
	mov	ax,0ffffh		;Non-EOF error
@freadline_99_a:
	stc				;Indicate error or EOF
@freadline_100:
	@restore
	ret
freadline endp



;+
; FUNCTION : blankline
;
;	Checks whether the line in linebuf is blank or not. Also treats it
;	as blank line if it begins with a `-'.
;
; Parameters:
;	None.
;
; Returns:
;	CF	= 0 if blank line, else 1.
; Register(s) destroyed:
;	AX,BX,CX,DX
;-
blankline proc	near
	@save	si
	mov	si,offset DGROUP:linebuf
	cmp	byte ptr [si],'-'		;Comment char ?
	jne	@blankline_20
	clc
	jmp	short @blankline_99
@blankline_20:
	mov	cx,lastchar
	sub	cx,si			;CX<-num chars in line
	call	near ptr skip_whitespace ;CF=1 if end of string
	cmc
@blankline_99:
	@restore
	ret
blankline endp


CSEG	ENDS

	END
